// RCInputDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RCInput.h"

#include <afxole.h>         // MFC OLE classes
#include <afxodlgs.h>       // MFC OLE dialog classes
#include <afxdisp.h >       // MFC OLE automation classes
#include <afxpriv.h>

#include "stdafx.h"
#include "RCInputDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static const CString sidesId("UDLRFB");
static BYTE curColors = 0, histColors[16][54] = {{0xaa, }, };

/////////////////////////////////////////////////////////////////////////////
// CRCInputDlg dialog

CRCInputDlg::CRCInputDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRCInputDlg::IDD, pParent),
      m_mObs(mo), m_yObs(1100), m_cube(150.f, &m_yObs, &m_mObs, &m_mMov)
{
   AfxOleInit(); 
	//{{AFX_DATA_INIT(CRCInputDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
 	m_hiRedo = AfxGetApp()->LoadIcon(IDI_BTNREDO);
	m_hiUndo = AfxGetApp()->LoadIcon(IDI_BTNUNDO);
   m_pWnd = pParent;
   m_autoCompleteEnable = true;
   m_cubeShow = false;
   m_flgML = false;
}

/////////////////////////////////////////////////////////////////////////////
// CRCInputDlg message handlers

BOOL CRCInputDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL) {
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty()) {
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

  // cree les positions des touches facettes 
   CRect rect;
   GetDlgItem(IDC_RCINP)->GetWindowRect(rect);
   ScreenToClient(rect);
   rect.DeflateRect(5,10,5,5);
   ComputRCSides(rect, facetsRect);

   ((CButton*)GetDlgItem(ID_BTNREDO))->SetIcon(m_hiRedo);
   ((CButton*)GetDlgItem(ID_BTNUNDO))->SetIcon(m_hiUndo);

   ((CButton*)GetDlgItem(ID_CHK_ROTA))->SetCheck(1);
   ((CButton*)GetDlgItem(ID_CHK_PERMUT))->SetCheck(1);

   GetDlgItem(IDC_RUBIXCUBE)->GetWindowRect(m_rectRC);
   ScreenToClient(m_rectRC);
   m_cube.SetScreen(m_rectRC.Width(), m_rectRC.Height());

	EnableToolTips(TRUE);
   OnColerase();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRCInputDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
      CDialog(IDD_ABOUTBOX).DoModal();
   else
		CDialog::OnSysCommand(nID, lParam);
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRCInputDlg::OnPaint() 
{
   static bool cubeShow = false;
	CPaintDC dc(this); // device context for painting

	if (IsIconic()) {
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);

   } else {

      dc.SetBkMode(TRANSPARENT);
      CFont *pFont = dc.SelectObject(GetFont());

      // draw the buttons facets
      for (BYTE n = 0; n < 54; n++) {
         BYTE color = m_colors[n] & 0x0f;
         CRect r = facetsRect[n];

         dc.DrawFrameControl(r, DFC_BUTTON, DFCS_BUTTONPUSH);
         r.DeflateRect(3, 3);
         dc.FillRect(r, GetBrush(color));

         if (n % 9 == 4) {
            // central facet, rotation display
            BYTE or = m_colors[n];

            or = (or >= 0x40)? 0: or >> 4;
            dc.SetTextColor(RGBTextColor(color));
            dc.DrawText(CentersString(n / 9, or, "UDLRFB"),
                                   r, DT_CENTER|DT_SINGLELINE|DT_VCENTER);
         }
      }

      dc.SelectObject(pFont);

      if (m_cubeShow) {
         // display the Rubik's Cube

         CubesUpdate(m_cube);

         dc.SetWindowOrg(-m_rectRC.left, -m_rectRC.top);

         m_cube.Draw(&dc);
      }
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRCInputDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_MESSAGE_MAP(CRCInputDlg, CDialog)
	//{{AFX_MSG_MAP(CRCInputDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_QUERYDRAGICON()
	ON_WM_DRAWITEM()
	ON_WM_MEASUREITEM()
	ON_WM_PAINT()
	ON_BN_CLICKED(ID_COLERASE, OnColerase)
	ON_BN_CLICKED(ID_CINIT, OnCinit)
	ON_WM_CONTEXTMENU()
	ON_BN_CLICKED(ID_CHK_ROTA, OnChkTests)
	ON_BN_CLICKED(ID_BTNUNDO, OnBtnundo)
	ON_BN_CLICKED(ID_BTNREDO, OnBtnredo)
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_BN_CLICKED(ID_CHK_PERMUT, OnChkTests)
	ON_BN_CLICKED(ID_BTN_COPY, OnBtnCopy)
	//}}AFX_MSG_MAP

   // context menu items
	ON_COMMAND_RANGE(ID_FACE_R0, ID_FACE_R3, OnOrientFace)
	ON_COMMAND_RANGE(ID_COLOR_0, ID_COLOR_5, OnSetColor)
   ON_COMMAND(ID_COLOR_DELETE, OnDelColor)
   ON_COMMAND(ID_LINKCOLORS_DELETE, OnDelLinkColors)
   ON_COMMAND(ID_FILL_COLORS, OnFillFullSide)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ToolTips

int CRCInputDlg::OnToolHitTest(CPoint point, TOOLINFO *pTI) const
{
   CWnd *pWnd;

   if (m_hWnd && (pWnd = ChildWindowFromPoint(point, CWP_SKIPINVISIBLE))) {
      UINT id = pWnd->GetDlgCtrlID();

      pTI->hinst = ::AfxGetInstanceHandle();
	   pTI->hwnd = m_hWnd;

      if (id != IDC_RCINP) {
         // the tooltips is created if a message exists for this object
         pTI->uFlags = TTF_ALWAYSTIP|TTF_IDISHWND;
         pTI->uId  = (UINT)pWnd->m_hWnd;
         pTI->lpszText = (LPSTR)id;
         return id;

      } else {
         // there is no object detected
         for (BYTE i = 0; i < 54; i++) {
            if (facetsRect[i].PtInRect(point)) {
               static CString msg;
               msg = completion.GetPossibleMsg(i, m_colors);
               // the point intercepts a facet of the Cube, type selection

               pTI->uFlags = TTF_ALWAYSTIP;
	            pTI->rect = facetsRect[i];
               pTI->uId  = id;
               pTI->lpszText = msg.GetBuffer(0);
               return id + 1 + i;
            }
         }
      }
   }
   return -1;
}

/////////////////////////////////////////////////////////////////////////////
// Deduces the position of the elementary cubies from the facets colors,
//    and updates the Rubik's Cube

bool CRCInputDlg::CubesUpdate(CCubes &cubes)
{
   CCubes work; 
   int er;

   // generates a Rubik's Cube from the facet color table
   if ( (er = work.Create(m_colors, true)) != 0 ) {
      // errors
      Invalidate();
      MessageBox(GetErrorMessage(er) + "Vrifiez les donnes introduites !");
      return false;

   // final checks
   } else if ( (er = work.ColorsCheck())!= 0
                           && MessageBox( GetErrorMessage(er) +
                   "Le Cube ne peut tre ordonn ! Voulez-vous corriger ?",
                        NULL, MB_ICONQUESTION|MB_YESNO ) == IDYES ) {
      return false;
   }
   // update the Rubik's Cube
   cubes = work;
   cubes.Comput();
   return true;
}

/////////////////////////////////////////////////////////////////////////////
// functions

bool CRCInputDlg::IsComplete() const
{
   for (int i = 0; i < 54; i++)
      if (m_colors[i] == 0xff)
         return false;
   return true;
}

bool CRCInputDlg::IsFullDelete() const
{
   for (int i = 0; i < 54; i++)
      if (m_colors[i] != 0xff)
         return false;
   return true;
}

void CRCInputDlg::CompletionMsg(bool save)
{
   CString msg = completion.getErrorMsg();

   GetDlgItem(IDC_EDT_MSG)->SetWindowText(msg);

   if (save && memcmp(histColors[curColors], m_colors, 54)!= 0) {
      // count modulo 16
      curColors = (curColors + 1) & 0x0f;
      memcpy(histColors[curColors], m_colors, 54);
      // place the flag at the end of registration, which is also the start flag
      histColors[(curColors + 1) & 0x0f][0] = 0xaa;
   }
   
   OkValidate();
	Invalidate();
}

void CRCInputDlg::OkValidate()
{
   bool redo = histColors[(curColors + 1) & 0x0f][0] != 0xaa;
   bool undo = histColors[(curColors - 1) & 0x0f][0] != 0xaa;
   bool ic = IsComplete();

   m_cubeShow = ic;
   GetDlgItem(ID_BTN_COPY)->EnableWindow(ic);
   GetDlgItem(ID_COLERASE)->EnableWindow(!IsFullDelete());

   GetDlgItem(ID_BTNREDO)->EnableWindow(redo);
   GetDlgItem(ID_BTNUNDO)->EnableWindow(undo);
}

/////////////////////////////////////////////////////////////////////////////
// CDiagInp message handlers

void CRCInputDlg::OnDrawItem(int nIDCtl, DRAWITEMSTRUCT *pDis) 
{
   CRect r = pDis->rcItem;
   HDC hDC = pDis->hDC;

   if (nIDCtl == 0) {
      // draw the menu entries for colors selection
      HBRUSH hbColor = (HBRUSH)GetBrush(BYTE(pDis->itemData))->m_hObject;
      HBRUSH hbOld = (HBRUSH)::SelectObject(hDC, hbColor);
      int x = r.right + r.left, x0 = x / 4, x1 = (2 * x)/ 3;
      ::Rectangle(hDC, x0, r.top + 1, x1, r.bottom - 1);
      ::SelectObject(hDC, hbOld);
   }
}

void CRCInputDlg::OnMeasureItem(int nIDCtl,
                                LPMEASUREITEMSTRUCT lpMeasureItemStruct) 
{
   if (nIDCtl == 0) {
      // definition of the dimensions of a menu entry
      lpMeasureItemStruct->itemHeight = ::GetSystemMetrics(SM_CYMENUCHECK);
      lpMeasureItemStruct->itemWidth = ::GetSystemMetrics(SM_CXMENUCHECK) * 4;
   }
}

/////////////////////////////////////////////////////////////////////////////
// Button commands

void CRCInputDlg::OnColerase() 
{
   memset(m_colors, 0xff, 54);

   completion.Get(m_colors);
   m_autoCompleteEnable = true;
   CompletionMsg(true);
}

void CRCInputDlg::OnCinit() 
{
   for (BYTE i = 0; i < 54; i++) m_colors[i] = defNoColor(i);

   completion.Get(m_colors);
   m_autoCompleteEnable = true;
   CompletionMsg(true);
}

void CRCInputDlg::OnChkTests() 
{
   BYTE options = 0; 

   if ( ((CButton*)GetDlgItem(ID_CHK_ROTA))->GetCheck()== 1 )   options  = 1;
   if ( ((CButton*)GetDlgItem(ID_CHK_PERMUT))->GetCheck()== 1 ) options |= 2;
   completion.SetOptions(options);

   completion.Get(m_colors);

   if (m_autoCompleteEnable) completion.Update(m_colors);

   CompletionMsg(true);
}

/////////////////////////////////////////////////////////////////////////////
// Context Menu

void CRCInputDlg::OnContextMenu(CWnd* pWnd, CPoint point) 
{
   CPoint pt = point;

   // search facet corresponding to the cursor position
   ScreenToClient(&pt);
   for (m_facetNo = 0; !facetsRect[m_facetNo].PtInRect(pt); m_facetNo++)
      if (m_facetNo == 53) return;     // exit, not found

   // create the orientation and colors menu for this face
   HMENU hMenu = ::CreatePopupMenu();

   if (m_facetNo % 9 == 4)
      PopulateOrientMenu(hMenu, ID_FACE_R0, m_facetNo, m_colors[m_facetNo],
                                          "UDLRFB");

   t_COLORS colors = completion.GetPossibleColors(m_facetNo, m_colors);
   BYTE flags = (completion.FillFullSide(m_facetNo, m_colors, false)> 0)? 3: 1;

   PopulateColorsMenu(hMenu, ID_COLOR_0, colors, flags);

   // Display a menu at the cursor position
   ::TrackPopupMenu(hMenu, TPM_LEFTALIGN|TPM_TOPALIGN,
                point.x, point.y, 0, m_hWnd, NULL);
}

void CRCInputDlg::OnOrientFace(UINT id) 
{
   BYTE or = BYTE(id - ID_FACE_R0);

   m_colors[m_facetNo] = (m_colors[m_facetNo] & 0x0F) | (or << 4);
   CompletionMsg(true);
}

void CRCInputDlg::OnSetColor(UINT id)
{
   // sets the color of this facet
   m_autoCompleteEnable = true;
   completion.SetAt(m_facetNo, BYTE(id - ID_COLOR_0), m_colors,
                                       m_autoCompleteEnable);
   CompletionMsg(true);
}

void CRCInputDlg::OnDelColor()
{
   m_autoCompleteEnable = false;
   completion.SetAt(m_facetNo, 0xff, m_colors, m_autoCompleteEnable);
   CompletionMsg(true);
}

void CRCInputDlg::OnDelLinkColors()
{
   m_autoCompleteEnable = false;
   completion.DelLinked(m_facetNo, m_colors);
   CompletionMsg(true);
}

void CRCInputDlg::OnFillFullSide()
{
   m_autoCompleteEnable = false;
   completion.FillFullSide(m_facetNo, m_colors, true);
   CompletionMsg(true);
}

/////////////////////////////////////////////////////////////////////////////
// Undo / Redo

void CRCInputDlg::OnBtnundo() 
{
   m_autoCompleteEnable = false;
	curColors = (curColors - 1) & 0x0f;
   memcpy(m_colors, histColors[curColors], 54);
   completion.Get(m_colors);
   CompletionMsg(false);
}

void CRCInputDlg::OnBtnredo() 
{
   m_autoCompleteEnable = false;
	curColors = (curColors + 1) & 0x0f;
   memcpy(m_colors, histColors[curColors], 54);
   completion.Get(m_colors);
   CompletionMsg(false);
}

/////////////////////////////////////////////////////////////////////////////
// Movements of the rubik's cube

void CRCInputDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
   CRect rect, box = m_cube.GetBox();

   box += m_rectRC.TopLeft();
   if (box.PtInRect(point)) m_posML = point, m_flgML = true;
	
	CDialog::OnLButtonDown(nFlags, point);
}

void CRCInputDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	if (m_flgML) {
		CPoint mv = m_posML - point;
		m_mObs.PosRotate(mv.y, mv.x);
		InvalidateRect(m_cube.Comput() + m_rectRC.TopLeft(), TRUE);
	}
	m_posML = point;
	
	CDialog::OnMouseMove(nFlags, point);
}

void CRCInputDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_flgML = false;

	CDialog::OnLButtonUp(nFlags, point);
}

/////////////////////////////////////////////////////////////////////////////
// Copy to clipboard

void CRCInputDlg::OnBtnCopy() 
{
	COleDataSource*	pSource = new COleDataSource();
   CString text = m_cube.ConvertString(TFMT_RBX);
	UINT len = text.GetLength() + 1;
   HGLOBAL hGlobal = ::GlobalAlloc(GMEM_MOVEABLE|GMEM_DDESHARE, len);
   LPVOID pt = ::GlobalLock(hGlobal);

   memcpy(pt, text.GetBuffer(0), len);
   ::GlobalUnlock(hGlobal);
	pSource->CacheGlobalData(CF_TEXT, hGlobal);
	pSource->SetClipboard();
}

/////////////////////////////////////////////////////////////////////////////

