// RCInputDlg.h : header file
//

#if !defined(AFX_RCINPUTDLG_H__F033896B_7DFF_467D_BB27_480087DED699__INCLUDED_)
#define AFX_RCINPUTDLG_H__F033896B_7DFF_467D_BB27_480087DED699__INCLUDED_

#include "Matrix.h"
#include "Cubes.h"
#include "Completion.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// matrix  for the presentation of the Cube
static const float mo[3][3] = {
   {0.916f,0.382f,0.142f},{-0.407f,0.856f,0.334f},{0.0f,-0.363f,0.935f}
};
/////////////////////////////////////////////////////////////////////////////
// CRCInputDlg dialog

class CRCInputDlg : public CDialog
{
// Construction
public:
	CRCInputDlg(CWnd* pParent = NULL);

// Dialog Data
	//{{AFX_DATA(CRCInputDlg)
	enum { IDD = IDD_DIAG_INP };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

   bool CubesUpdate(CCubes &cubes);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRCInputDlg)
	protected:
	virtual BOOL OnInitDialog();
	virtual int OnToolHitTest(CPoint point, TOOLINFO* pTI) const;
	//}}AFX_VIRTUAL

// Implementation
protected:
   CWnd     *m_pWnd;          // parent

   HICON    m_hIcon;
   HICON    m_hiRedo;
   HICON    m_hiUndo;

   BYTE     m_facetNo;        // number of selected facet with ContextMenu

   CRect    facetsRect[54];   // rectangles corresponding to the key facets
   BYTE     m_colors[54];     // facets colors to update

   bool     m_cubeShow;
   CCubes   m_cube;
   CRect    m_rectRC;
   int      m_yObs;
	CMatrix  m_mObs;
	CMatrix  m_mMov;
   CPoint   m_posML;
   bool     m_flgML;


   bool m_autoCompleteEnable;
   CCompletion completion;    // computs completion

   bool IsComplete() const;
   bool IsFullDelete() const;

   void OkValidate();

   void CompletionMsg(bool save = true);

	// Generated message map functions
	//{{AFX_MSG(CRCInputDlg)
   afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
   afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
	afx_msg void OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct);
	afx_msg void OnPaint();
	afx_msg void OnColerase();
	afx_msg void OnCinit();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnChkTests();
	afx_msg void OnBtnundo();
	afx_msg void OnBtnredo();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnBtnCopy();
	//}}AFX_MSG

	afx_msg void OnOrientFace(UINT id);
	afx_msg void OnBtnSym(UINT id);
   afx_msg void OnSetColor(UINT id);
   afx_msg void OnDelColor();
   afx_msg void OnDelLinkColors();
   afx_msg void OnFillFullSide();

	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RCINPUTDLG_H__F033896B_7DFF_467D_BB27_480087DED699__INCLUDED_)
